#ifndef SCENE_H
#define SCENE_H

#include <QGraphicsScene>
#include <QGraphicsSceneMouseEvent>
#include <QGraphicsEllipseItem>
#include <QTimer>

const double SPEED_FACTOR = 1.0;
const int BALL_SIZE = 40;
const int UPDATE_INTERVAL = 20;
const int USE_ANTIALIASING = true;
const int WIDTH = 700;
const int HEIGHT = 500;

class Ball : public QGraphicsEllipseItem
{
public:
    Ball(const QRectF &rect) :QGraphicsEllipseItem(rect) {}

    // direction vector
    qreal directionX;
    qreal directionY;
};

class Scene : public QGraphicsScene
{
    Q_OBJECT
public:
    Scene();

private:
    QList<Ball *> balls;
    
    QTimer stepTimer;
    
private slots:
    void step();
    
protected:
    void mousePressEvent(QGraphicsSceneMouseEvent *mouseEvent);
};

#endif //SCENE
